searchNodes=[{"doc":"Defines the an OnePiece.Commanded.Aggregate behaviour.","ref":"OnePiece.Commanded.Aggregate.html","title":"OnePiece.Commanded.Aggregate","type":"behaviour"},{"doc":"Convert the module into a Aggregate behaviour. Usage defmodule Account do use OnePiece.Commanded.Aggregate @impl OnePiece.Commanded.Aggregate def apply ( account , event ) do account |&gt; Map . put ( :name , event . name ) |&gt; Map . put ( :description , event . description ) end end","ref":"OnePiece.Commanded.Aggregate.html#__using__/1","title":"OnePiece.Commanded.Aggregate.__using__/1","type":"macro"},{"doc":"Apply a given event to the aggregate returning the new aggregate state. Example def apply ( account , event ) do account |&gt; Map . put ( :name , event . name ) |&gt; Map . put ( :description , event . description ) end","ref":"OnePiece.Commanded.Aggregate.html#c:apply/2","title":"OnePiece.Commanded.Aggregate.apply/2","type":"callback"},{"doc":"","ref":"OnePiece.Commanded.Aggregate.html#t:event/0","title":"OnePiece.Commanded.Aggregate.event/0","type":"type"},{"doc":"","ref":"OnePiece.Commanded.Aggregate.html#t:t/0","title":"OnePiece.Commanded.Aggregate.t/0","type":"type"},{"doc":"Defines a module as a &quot;Command&quot;. For more information about commands, please read the following: CQRS pattern","ref":"OnePiece.Commanded.Command.html","title":"OnePiece.Commanded.Command","type":"module"},{"doc":"Converts the module into an Ecto.Schema , and derive from Jason.Encoder . Usage defmodule MyCommand do use OnePiece.Commanded.Command , aggregate_identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Command.html#__using__/1","title":"OnePiece.Commanded.Command.__using__/1","type":"macro"},{"doc":"","ref":"OnePiece.Commanded.Command.html#t:t/0","title":"OnePiece.Commanded.Command.t/0","type":"type"},{"doc":"Defines a module as a &quot;Command Handler&quot;. For more information about commands, please read the following: CQRS pattern","ref":"OnePiece.Commanded.CommandHandler.html","title":"OnePiece.Commanded.CommandHandler","type":"module"},{"doc":"Convert the module into a Commanded.Commands.Handler . Use Commanded.Aggregate.Multi to generate multiple events from a single command. This can be useful when you want to emit multiple events that depend upon the aggregate state being updated. Usage defmodule MyCommandHandler do use OnePiece.Commanded.CommandHandler @impl Commanded.Commands.Handler def handle ( account , command ) do account |&gt; Multi . new ( ) |&gt; Multi . execute ( &amp; withdraw_money ( &amp;1 , command . amount ) ) |&gt; Multi . execute ( &amp; check_balance / 1 ) end defp withdraw_money ( account , amount ) do # ... end defp check_balance ( account , amount ) do # ... end end","ref":"OnePiece.Commanded.CommandHandler.html#__using__/1","title":"OnePiece.Commanded.CommandHandler.__using__/1","type":"macro"},{"doc":"Defines a module as an &quot;Entity&quot; in the context of Domain-Driven Design.","ref":"OnePiece.Commanded.Entity.html","title":"OnePiece.Commanded.Entity","type":"module"},{"doc":"Converts the module into an Ecto.Schema , and derive from Jason.Encoder . Usage defmodule MyEntity do use OnePiece.Commanded.Entity , identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Entity.html#__using__/1","title":"OnePiece.Commanded.Entity.__using__/1","type":"macro"},{"doc":"The identity of an entity.","ref":"OnePiece.Commanded.Entity.html#t:identity/0","title":"OnePiece.Commanded.Entity.identity/0","type":"type"},{"doc":"Defines a module as a &quot;Event&quot; in terms of Event Sourcing context. For more information about Event Sourcing, please read the following: Event Sourcing pattern","ref":"OnePiece.Commanded.Event.html","title":"OnePiece.Commanded.Event","type":"module"},{"doc":"Converts the module into an Ecto.Schema , and derive from Jason.Encoder . Usage defmodule MyEvent do use OnePiece.Commanded.Event , aggregate_identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Event.html#__using__/1","title":"OnePiece.Commanded.Event.__using__/1","type":"macro"},{"doc":"","ref":"OnePiece.Commanded.Event.html#t:t/0","title":"OnePiece.Commanded.Event.t/0","type":"type"},{"doc":"A Swiss Army Knife Helper Module.","ref":"OnePiece.Commanded.Helpers.html","title":"OnePiece.Commanded.Helpers","type":"module"},{"doc":"Deprecated, it has the same behavior as OnePiece.Commanded.Id.new/0 .","ref":"OnePiece.Commanded.Helpers.html#generate_uuid/0","title":"OnePiece.Commanded.Helpers.generate_uuid/0","type":"function"},{"doc":"Transforms the given source map or struct into the target struct.","ref":"OnePiece.Commanded.Helpers.html#struct_from/2","title":"OnePiece.Commanded.Helpers.struct_from/2","type":"function"},{"doc":"A module for dealing IDs.","ref":"OnePiece.Commanded.Id.html","title":"OnePiece.Commanded.Id","type":"behaviour"},{"doc":"Generates a UUID using the version 4 scheme, as described in RFC 4122 .","ref":"OnePiece.Commanded.Id.html#new/0","title":"OnePiece.Commanded.Id.new/0","type":"function"},{"doc":"Generates a new ID.","ref":"OnePiece.Commanded.Id.html#c:new/0","title":"OnePiece.Commanded.Id.new/0","type":"callback"},{"doc":"Defines a module as a &quot;Query Handler&quot;. For more information about queries, please read the following: CQRS pattern","ref":"OnePiece.Commanded.QueryHandler.html","title":"OnePiece.Commanded.QueryHandler","type":"behaviour"},{"doc":"Convert the module into a OnePiece.Commanded.QueryHandler . Usage defmodule MyQueryHandler do use OnePiece.Commanded.QueryHandler import Ecto.Query , only : [ from : 2 ] @impl OnePiece.Commanded.QueryHandler def handle ( params ) do query = from u in User , where : u . age &gt; 18 or is_nil ( params . email ) , select : u { :ok , Repo . all ( query ) } end end","ref":"OnePiece.Commanded.QueryHandler.html#__using__/1","title":"OnePiece.Commanded.QueryHandler.__using__/1","type":"macro"},{"doc":"Handle the incoming params and return the result data.","ref":"OnePiece.Commanded.QueryHandler.html#c:handle/1","title":"OnePiece.Commanded.QueryHandler.handle/1","type":"callback"},{"doc":"","ref":"OnePiece.Commanded.QueryHandler.html#t:error/0","title":"OnePiece.Commanded.QueryHandler.error/0","type":"type"},{"doc":"","ref":"OnePiece.Commanded.QueryHandler.html#t:view_model/0","title":"OnePiece.Commanded.QueryHandler.view_model/0","type":"type"},{"doc":"Implements Commanded.EventStore.TypeProvider behavior. Using macros to generate the behavior.","ref":"OnePiece.Commanded.TypeProvider.html","title":"OnePiece.Commanded.TypeProvider","type":"module"},{"doc":"Imports all the types from another module defined by OnePiece.Commanded.TypeProvider.TypeProvider . Example defmodule UserTypeProvider do use OnePiece.Commanded.TypeProvider # ... end defmodule MyAppTypeProvider do use OnePiece.Commanded.TypeProvider import_type_provider UserTypeProvider end","ref":"OnePiece.Commanded.TypeProvider.html#import_type_provider/1","title":"OnePiece.Commanded.TypeProvider.import_type_provider/1","type":"macro"},{"doc":"Registers a mapping from an name string to an Elixir Module that defines a struct. Example defmodule MyTypeProvider do use OnePiece.Commanded.TypeProvider , prefix : &quot;accounts.&quot; # optional, adds the prefix to the type name register_type &quot;account_created&quot; , AccountCreated end","ref":"OnePiece.Commanded.TypeProvider.html#register_type/2","title":"OnePiece.Commanded.TypeProvider.register_type/2","type":"macro"},{"doc":"Defines a module as a &quot;Value Object&quot;. For more information about value objects, please read the following: Value Object Wikipedia ValueObject by Martin Fowler","ref":"OnePiece.Commanded.ValueObject.html","title":"OnePiece.Commanded.ValueObject","type":"module"},{"doc":"Converts the module into an Ecto.Schema , and derive from Jason.Encoder . Usage defmodule MyValueObject do use OnePiece.Commanded.ValueObject embedded_schema do # ... end end","ref":"OnePiece.Commanded.ValueObject.html#__using__/1","title":"OnePiece.Commanded.ValueObject.__using__/1","type":"macro"},{"doc":"Extend Commanded package. A swiss army knife for applications following Domain-Driven Design (DDD), Event Sourcing ( ES), and Command and Query Responsibility Segregation (CQRS).","ref":"readme.html","title":"OnePiece.Commanded","type":"extras"},{"doc":"How-to Import Test Support files References API Reference Explanations Enhancing Testing Environments","ref":"readme.html#documentation","title":"OnePiece.Commanded - Documentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added OnePiece.Commanded.Id Deprecated OnePiece.Commanded.Helpers.generate_uuid/0 . Use OnePiece.Commanded.Id.new/0 instead.","ref":"changelog.html#v0-7-0-2022-02-14","title":"Changelog - v0.7.0 - 2022-02-14","type":"extras"},{"doc":"Added prefix option to using OnePiece.Commanded.TypeProvider defmodule MyTypeProvider do use OnePiece.Commanded.TypeProvider , prefix : &quot;accounts.&quot; end","ref":"changelog.html#v0-6-0-2022-02-14","title":"Changelog - v0.6.0 - 2022-02-14","type":"extras"},{"doc":"Added OnePiece.Commanded.TypeProvider","ref":"changelog.html#v0-5-0-2022-02-14","title":"Changelog - v0.5.0 - 2022-02-14","type":"extras"},{"doc":"Improve documentation","ref":"changelog.html#v0-4-0-2021-11-25","title":"Changelog - v0.4.0 - 2021-11-25","type":"extras"},{"doc":"Add OnePiece.Commanded.Event module","ref":"changelog.html#v0-4-0-2021-08-15","title":"Changelog - v0.4.0 - 2021-08-15","type":"extras"},{"doc":"Fix docs Fix version bump","ref":"changelog.html#v0-3-0-2021-08-15","title":"Changelog - v0.3.0 - 2021-08-15","type":"extras"},{"doc":"Add test support files","ref":"changelog.html#v0-2-1-2021-08-15","title":"Changelog - v0.2.1 - 2021-08-15","type":"extras"},{"doc":"Fix putting aggregate id to command function name","ref":"changelog.html#v0-2-0-2021-08-08","title":"Changelog - v0.2.0 - 2021-08-08","type":"extras"},{"doc":"Fix aliases","ref":"changelog.html#v0-1-3-2021-08-08","title":"Changelog - v0.1.3 - 2021-08-08","type":"extras"},{"doc":"Fix __using__ for aggregate, command handler, query handler, and value object","ref":"changelog.html#v0-1-2-2021-08-08","title":"Changelog - v0.1.2 - 2021-08-08","type":"extras"},{"doc":"Remove dead-code","ref":"changelog.html#v0-1-1-2021-08-08","title":"Changelog - v0.1.1 - 2021-08-08","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2021-08-08","title":"Changelog - v0.1.0 - 2021-08-08","type":"extras"},{"doc":"Open your test_helper.exs , add the following code-snippet before ExUnit.start() : one_piece_commanded_path = Mix.Project . deps_paths ( ) [ :one_piece_commanded ] Code . require_file &quot; \#{ one_piece_commanded_path } /test/test_support/command_handler_case.ex&quot; , __DIR__ # Code.require_file &quot;\#{one_piece_commanded_path}/test/test_support/[other test support file name here].ex&quot;, __DIR__ # ... ExUnit . start ( ) Verify that such files exists. Use the Test Support Modules in your test.","ref":"import-test-support-files.html","title":"Import Test Support files","type":"extras"},{"doc":"We publish some ExUnit.CaseTemplate as part of the package, we don't have that code to be compiled to production, or maintain a different package we must do some workaround the limitations problems, for now. The test support files are under test/test_support directory, since the modules is not under lib directory, Elixir will not load this module without importing the file manually. Read more about How-to import Test Support files . The Test support files are composed of the following modules: OnePiece.Commanded.TestSupport.CommandHandlerCase in test/test_support/command_handler_case.ex helpful for testing command handler use cases.","ref":"enhancing-testing-environments.html","title":"Enhancing Testing Environments","type":"extras"}]